(******************************************************************************
 * AcCalendar                                                                 *
 *                                                                            *
 * Domenica, 05/Agosto/2001                                                   *
 * -------------------------------------------------------------------------- *
 *         Il giorno non veniva segnato in modo corretto                      *
 *                                                                            *
 *         Se il calendario segnava il mese di dicembre e si cliccava su un   *
 *         giorno dell'anno successivo il calendario non avanzava in modo     *
 *         corretto                                                           *
 *         Se il calendario segnava il mese di gennaio e si cliccava su un    *
 *         giorno dell'anno precedente il calendario non retrocedeva in modo  *
 *         corretto                                                           *
 *                                                                            *
 *         Correzione del calcolo del numero dei giorni                       *
 *                                                                            *
 * Luned, 28 Aprile 2003                                                     *
 * -------------------------------------------------------------------------- *
 *         Con delphi 6 il finfresco della finestra non veniva corretto       *
 *         al posto di disegnare il titolo  stata inserita una Label(Titolo) *
 ******************************************************************************)
unit ACCalendar;

(******************************************************************************
 * Interface                                                                  *
 ******************************************************************************)
interface

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, Stdctrls, Menus;

(******************************************************************************
 * Type                                                                       *
 ******************************************************************************)
type
  TACGraphiControl = Class(TGraphicControl)
  Public
    Property Canvas;
  End;

  TACCalendar = class(TCustomControl)
  private
    { Private declarations }
    Mio_Anno  : Word;
    Mio_Mese  : Word;
    Mio_Giorno : Word;

    Btn1,                // Bottone mese precedente
    Btn2,                // Bottone mese succcessivo
    Btn3,                // Bottone anno successivo
    Btn4 : TSpeedButton; // Bottone anno precedente
    Titolo : TLabel;
//    Titolo : TLabel;
//    Fondo  : TLabel;
//    Sopra  : TLabel;
    Blocca_Paint : Boolean;
    Riga    : Integer; // Indica la riga in cui inserire la prossima data
    Colonna : Integer; // Indica la colonna in cui inserire la prossima data

    Giorni_Pre,           // Numero di giorni del mese precedente visibili
    Giorni_Suc : Integer; // Numero di giorni del mese precedente visibili

    Lock_Update  : Boolean; // Server per bloccare l'aggiornamento
                            // al cambio di data, in caso contrario dato che
                            // si cambia giorno, mese ed anno si vedrebbe per
                            // 3 volte lo sfarfallio

    Titolo_sx,           // Indica l'estremo sinistro della scritta del nome del mese
    Titolo_dx : Integer; // Indica l'estremo destro della scritta del nome del mese
                         // Vengono usate per sapere se si  cliccato all'interno
                         // del nome del mese per mostrare il menu con l'elenco dei
                         // mesi
    Altezza_Titolo : Integer; // Indica l'altezza della scritta del nome del mese

    Sub_Menu       : TPopupMenu; // Menu contenente l'elenco dei mesi
    Sub_Item       : Array[1..12] of TMenuItem;
    F_DateClick    : TNotifyEvent;
  protected
    { Protected declarations }

    Function Get_Numero_Giorni(Mese,Anno:Integer):Integer;
    Procedure Insert_Data(Day:Integer;Mese_Corrente:Boolean);
    Procedure Mouse_Down(Var msg:TMessage); message WM_LBUTTONDOWN;
    Procedure Disegna(Var msg:TMessage); message WM_PAint;
    Procedure Key_Down(Var msg:TMessage); message WM_CHAR;
    Procedure Click_Btn(Sender:Tobject);
    Procedure Disegna_Gr(gr:Integer;Cnv:TCanvas;x,y:Integer);
    procedure Disegna_Finestra(Anche_Fondo:Boolean);
    Procedure Disegna_Bordo;
    Procedure Set_Null(Index:Integer;Num:Word);
    Function  Get_Now(Index:Integer):Word;
    Procedure Set_Mio_Giorno(Num:Word);
    Procedure Set_Mio_Mese(Num:Word);
    Procedure Set_Mio_Anno(Num:Word);
    Procedure OnMenuSelectMese(Sender:Tobject);
    Function Get_Const(Index:Integer):Integer;
    procedure Titolo_MouseDown(Sender: TObject; Button: TMouseButton;
                               Shift: TShiftState; X, Y: Integer);



    Property  DISTANZA_TRA_GIORNI : Integer index 1 Read Get_Const;
    Property  MARGINE_OR          : Integer index 2 Read Get_Const;
    Property  MARGINE_VR          : Integer index 3 Read Get_Const;
    Property  ALTEZZA_RIGA        : Integer index 4 Read Get_Const;
    Property  MARGINE_SOPRA       : Integer index 5 Read Get_Const;
    Property  TOP_LINEA           : Integer index 6 Read Get_Const;
    Property  TOP_OGGI            : Integer index 7 Read Get_Const;
    Property  POSY_TITOLO         : Integer index 8 Read Get_Const;
    Property  LEFT_OGGI           : Integer index 9 Read Get_Const;
    Property  TOP_MESI            : Integer index 10 Read Get_Const;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); Override;
    destructor Destroy; Override;
    Procedure Vai_Oggi;
  published
    { Published declarations }
    Property Giorno : Word Read Mio_Giorno Write Set_Mio_Giorno stored False;
    Property Mese   : Word Read Mio_Mese   Write Set_Mio_Mese stored False;
    Property Anno   : Word Read Mio_Anno   Write Set_Mio_Anno stored False;

    Property Cor_Giorno : Word index 0 Read Get_Now Write Set_Null;
    Property Cor_Mese   : Word index 1 Read Get_Now Write Set_Null;
    Property Cor_Anno   : Word index 2 Read Get_Now Write Set_Null;
    Property Visible;
    Property OnDateClick : TNotifyEvent Read F_DateClick Write F_DateClick;

  end;


(******************************************************************************
 * Implementation                                                             *
 ******************************************************************************)
implementation

{$R ACCalResource.Res }

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
uses AcConst;


(******************************************************************************
 * constructor                                                                *
 ******************************************************************************)
constructor TACCalendar.Create(AOwner: TComponent);
Var c1 : Integer;
Begin
  Inherited;

  Blocca_Paint := False;

  Height := 158;
  Width  := 165;

  Titolo_Sx      := -1;
  Titolo_Dx      := -1;
  Altezza_Titolo := 0;

  OnDateClick    := Nil;
//********* Bottoni **********
  Btn1        := TSpeedButton.Create(Self);
  Btn1.Parent := Self;
  Btn1.Left   := 9*Screen.PixelsPerInch div DPI_SCHERMOBASE;
  Btn1.Top    := 9*Screen.PixelsPerInch div DPI_SCHERMOBASE;;
  Btn1.Height := 15*Screen.PixelsPerInch div DPI_SCHERMOBASE;;
  Btn1.Width  := 19*Screen.PixelsPerInch div DPI_SCHERMOBASE;;
  Btn1.OnClick := Click_Btn;

  Btn2        := TSpeedButton.Create(Self);
  Btn2.Parent := Self;
  Btn2.Left   := (141*Screen.PixelsPerInch) div DPI_SCHERMOBASE;
  Btn2.Top    := (9*Screen.PixelsPerInch) div DPI_SCHERMOBASE;
  Btn2.Height := (15*Screen.PixelsPerInch) div DPI_SCHERMOBASE;
  Btn2.Width  := (19*Screen.PixelsPerInch) div DPI_SCHERMOBASE;
  Btn2.OnClick := Click_Btn;

  Btn3         := TSpeedButton.Create(Self);
  Btn3.Parent  := Self;
  Btn3.Left    := (126*Screen.PixelsPerInch) div DPI_SCHERMOBASE;
  Btn3.Top     := (6*Screen.PixelsPerInch) div DPI_SCHERMOBASE;
  Btn3.Height  := (10*Screen.PixelsPerInch) div DPI_SCHERMOBASE;
  Btn3.Width   := (14*Screen.PixelsPerInch) div DPI_SCHERMOBASE;
  Btn3.OnClick := Click_Btn;
  Btn3.Visible := False;

  Btn4         := TSpeedButton.Create(Self);
  Btn4.Parent  := Self;
  Btn4.Left    := (126*Screen.PixelsPerInch) div DPI_SCHERMOBASE;
  Btn4.Top     := (16*Screen.PixelsPerInch) div DPI_SCHERMOBASE;
  Btn4.Height  := (10*Screen.PixelsPerInch) div DPI_SCHERMOBASE;
  Btn4.Width   := (14*Screen.PixelsPerInch) div DPI_SCHERMOBASE;
  Btn4.OnClick := Click_Btn;
  Btn4.Visible := False;

  btn1.Glyph.LoadFromResourceName(HInstance,'Indietro');
  btn2.Glyph.LoadFromResourceName(HInstance,'Avanti');
  btn3.Glyph.LoadFromResourceName(HInstance,'Sopra');
  btn4.Glyph.LoadFromResourceName(HInstance,'Sotto');


//********** Titolo **********
  Titolo             := Tlabel.Create(Self);
  Titolo.Autosize    := True;
  Titolo.Parent      := Self;
  Titolo.Top         := POSY_TITOLO;
  Titolo.Left        := 3;
  Titolo.Width       := Width - 6;
  Titolo.Height      := MARGINE_SOPRA-3;
  Titolo.Color       := clBtnFace;
  Titolo.Alignment   := taCenter;
  Titolo.OnMouseDown := Titolo_MouseDown;
  Titolo.Caption     := '';


//********** Data *********
  Lock_Update := False;
  DecodeDate(Now,Mio_Anno,Mio_Mese,Mio_Giorno);

//********** Menu dei mesi *********
  Sub_Menu := TPopupMenu.Create(Self);
  For c1 := 1 to 12 Do
  Begin
    Sub_Item[c1]         := TMenuItem.Create(Self);
    Sub_Item[c1].Caption := LongMonthNames[c1];
    Sub_Item[c1].Tag     := c1;
    Sub_Item[c1].OnClick := OnMenuSelectMese;
    Sub_Menu.Items.Add(Sub_Item[c1]);
  End;

  Vai_Oggi;
End;

(******************************************************************************
 * Destructor                                                                 *
 ******************************************************************************)
destructor TACCalendar.Destroy;
Var c1 : Integer;
Begin
  Titolo.Free;
  Btn1.Free;
  Btn2.Free;
  For c1 := 12 downto 1 Do
  Begin
    Sub_Menu.Items.Delete(c1-1);
    Sub_Item[c1].Free;
  End;
  Sub_Menu.Free;
//  Titolo.Free;
  Inherited;
End;
(******************************************************************************
 * Disegna_Finestra                                                           *
 ******************************************************************************)
procedure TACCalendar.Disegna_Finestra(Anche_Fondo:Boolean);
Var
    c1,c2,c3   : Integer;
    Numero_Giorni, Numero : Integer; // Numero di giorni di un mese
    Txt           : String;

Begin
  if (Parent = Nil) then exit;
  Giorni_Pre := 0;
  Giorni_Suc := 0;
  Numero_Giorni := Get_Numero_Giorni(Mese,Anno);

//********** Le due parti della finestra ********
//********** La prima grigia in alto     ********
//********** La seconda bianca in basso  ********
  if (Anche_Fondo) then
  begin
//    Canvas.Brush.Color := clred;//clBtnFace;
//    Canvas.FillRect(Rect(0,0,Width,MARGINE_SOPRA));
    Canvas.Brush.Color := clWindow;
    Canvas.FillRect(Rect(0,MARGINE_SOPRA+1,Width,Height-1));
  end
  Else
  Begin
//    Canvas.Brush.Color := clred;//clBtnFace;
//    Canvas.FillRect(Rect(3,3,Width-3,MARGINE_SOPRA-3));
    Canvas.Brush.Color := clWindow;
    Canvas.FillRect(Rect(3,TOP_LINEA+1,Width-3,TOP_OGGI));

  End;

  Canvas.Brush.Style := bsClear;
//********** Linea di separazione *********
  if (Anche_Fondo) then
  begin
    Canvas.Pen.Color  := clBlack;
    Canvas.MoveTo(MARGINE_OR,      TOP_LINEA);
    Canvas.LineTo(Width-MARGINE_OR,TOP_LINEA);


//********* Stampa i nomi dei giorni *********
    for c1 := 1 to 7 do
    Begin
     Canvas.Font.Color := clGrayText;
     Canvas.Font.Style := [];

     Canvas.TextOut(DISTANZA_TRA_GIORNI*(c1-1)+
                    MARGINE_OR+
                    ((DISTANZA_TRA_GIORNI-Canvas.TextWidth(ShortDayNames[c1]))div 2),
                    TOP_MESI,
                    ShortDayNames[c1]);
    End;
  End;
//********* stampa giorni mese *********
  Riga    := 1;
  Colonna := 1;

  For c1 := 1 to Numero_Giorni do
  Begin
    c2 := DayOfWeek(EncodeDate(Mio_anno,Mio_Mese,c1));
//    if (c2=1) then c2 := 7
//    else dec(c2);
    if (c1=1)and(c2<>1) then
    begin
      Numero := Get_Numero_Giorni(Mese-1,Anno);
      for c3 := 1 to c2-1 do
      Begin
        Insert_Data(Numero-c2+c3+1,False);
      End;
      Giorni_Pre := c2-1;
    end;
    Insert_Data(c1,True);
  End;
//******** Stampa giorni mese successivo *********
  if (riga<7) then
  Begin
    c1 := 1;
    While(Riga<7) do
    begin
      Insert_Data(c1,False);
      inc(c1);
    end;
    Giorni_Suc := c1;
  End;



  Txt := LongMonthNames[Mese]+ ' '+ IntToStr(Anno);
//  Canvas.Font.Color := clWindowText;
//  Canvas.Font.Style := [fsBold];
//  Canvas.TextOut((Width-Canvas.TextWidth(txt)) div 2,POSY_TITOLO,txt);
//  Titolo_Sx      := (Width-Canvas.TextWidth(txt)) div 2;
//  Titolo_Dx      := Titolo_Sx+Canvas.TextWidth(LongMonthNames[Mese]);
//  Altezza_Titolo := Canvas.TextHeight(txt);

  Titolo.Font.Color := clWindowText;
  Titolo.Font.Style := [fsBold];
  Titolo.Caption    := txt;
  Titolo_sx         := (Width-Titolo.Canvas.TextWidth(txt)) div 2;
  Titolo_Dx         := Titolo.Canvas.TextWidth(LongMonthNames[Mese]);
  Titolo.Left       := Titolo_Sx;

//  Titolo.Caption  := ;
//  Titolo.Left     := () div 2;
  if (Anche_Fondo) then
  begin
    Disegna_Bordo;
    Disegna_Gr(1,Canvas,5,TOP_OGGI);
    Canvas.Font.Color := clWindowText;
    Canvas.Font.Style := [fsBold];
    Canvas.Brush.Style := bsClear;
    Canvas.TextOut(LEFT_OGGI,TOP_OGGI,'Oggi: '+DateToStr(Now));
    Canvas.Font.Style := Canvas.Font.Style - [fsBold];
  End;

End;

(******************************************************************************
 * Disegna                                                                    *
 ******************************************************************************)
procedure TACCalendar.Disegna(Var msg:TMessage);
begin
  if (Blocca_Paint) then exit;
  Blocca_Paint := True;
  Inherited;
  if (Height <> (158*Screen.PixelsPerInch) div DPI_SCHERMOBASE) then Height := (158*Screen.PixelsPerInch) div DPI_SCHERMOBASE;
  if (Width  <> (165*Screen.PixelsPerInch) div DPI_SCHERMOBASE) then Width  := (165*Screen.PixelsPerInch) div DPI_SCHERMOBASE;

  Btn1.Left   := 9*Screen.PixelsPerInch div DPI_SCHERMOBASE;
  Btn1.Top    := 9*Screen.PixelsPerInch div DPI_SCHERMOBASE;
  Btn1.Height := 15*Screen.PixelsPerInch div DPI_SCHERMOBASE;
  Btn1.Width  := 19*Screen.PixelsPerInch div DPI_SCHERMOBASE;

  Btn2.Left   := (141*Screen.PixelsPerInch) div DPI_SCHERMOBASE;
  Btn2.Top    := (9*Screen.PixelsPerInch) div DPI_SCHERMOBASE;
  Btn2.Height := (15*Screen.PixelsPerInch) div DPI_SCHERMOBASE;
  Btn2.Width  := (19*Screen.PixelsPerInch) div DPI_SCHERMOBASE;

  Btn3.Left    := (126*Screen.PixelsPerInch) div DPI_SCHERMOBASE;
  Btn3.Top     := (6*Screen.PixelsPerInch) div DPI_SCHERMOBASE;
  Btn3.Height  := (10*Screen.PixelsPerInch) div DPI_SCHERMOBASE;
  Btn3.Width   := (14*Screen.PixelsPerInch) div DPI_SCHERMOBASE;

  Btn4.Left    := (126*Screen.PixelsPerInch) div DPI_SCHERMOBASE;
  Btn4.Top     := (16*Screen.PixelsPerInch) div DPI_SCHERMOBASE;
  Btn4.Height  := (10*Screen.PixelsPerInch) div DPI_SCHERMOBASE;
  Btn4.Width   := (14*Screen.PixelsPerInch) div DPI_SCHERMOBASE;



  disegna_finestra(True);
  Blocca_Paint := false;
end;
(******************************************************************************
 * Click_Btn                                                                  *
 ******************************************************************************)
Procedure TACCalendar.Click_Btn(Sender:Tobject);
Begin
  if (Sender=Btn1) or (Sender=Btn2) then
  begin
    Btn3.Visible := False;
    Btn4.Visible := False;
  End;
//******** Mese precedente ********
  if (Sender = Btn1) then
  Begin
    Dec(Mio_Mese);
    if (Mio_Mese<=0) then
    begin
      dec(Mio_Anno);
      Mio_Mese := 12;
    end;
    Disegna_Finestra(False);
  End;
//******** Mese successivo ********
  if (Sender = Btn2) then
  Begin
    Inc(Mio_Mese);
    if (Mio_Mese>=12) then
    begin
      Inc(Mio_Anno);
      Mio_Mese := 1;
    end;
    Disegna_Finestra(False);
  End;
//******** Anno precedente ********
  if (Sender = Btn4) then
  Begin
    if (Anno>1) then
    Begin
      Anno := anno-1;
    end;
  End;
//******** Anno successivo ********
  if (Sender = Btn3) then
  Begin
    Anno := anno + 1;
  End;
End;

(******************************************************************************
 * Get_Numero_Giorni                                                          *
 *                                                                            *
 * Se il numero del mese e' inferiore a 1, vuol dire che si fa riferimeno     *
 * all'anno precedente e il numero del mese va calcolato a ritroso partendo   *
 * da dicembre                                                                *
 ******************************************************************************)
Function TACCalendar.Get_Numero_Giorni(Mese,Anno:Integer):Integer;
Var Numero : Integer;
Begin
  if (Mese<1) then
  begin
    mese := 12+mese;
    Anno := anno-1;
  End;
  Numero := 28;
  if (Mese<0) then
  begin
    Mese := 12;
    Dec(Anno);
  end;
  if (Mese>12) then
  begin
    Mese := 1;
    Inc(Anno);
  end;

  Case Mese of
   1: Numero := 31;
   2:
      Begin
        Numero := 28;
        if (Anno Mod 4=0) and (Anno Mod 100<>0) then Numero := 29;
        if (Anno Mod 4=0) and (Anno Mod 400=0) then Numero := 29;
      End;
   3: Numero := 31;
   4: Numero := 30;
   5: Numero := 31;
   6: Numero := 30;
   7: Numero := 31;
   8: Numero := 31;
   9: Numero := 30;
   10: Numero := 31;
   11: Numero := 30;
   12: Numero := 31;
  End;
  Get_Numero_Giorni := Numero;
End;

(******************************************************************************
 * Insert_Data                                                                *
 ******************************************************************************)
Procedure TACCalendar.Insert_Data(Day:Integer;Mese_Corrente:Boolean);
Var Lar_Testo : Integer;
    x,y       : Integer;
Begin
  Lar_Testo := Canvas.TextWidth(IntToStr(Day));
  if (Mese_Corrente) then Canvas.Font.Color := clWindowText
  Else Canvas.Font.Color := clGray;
  Canvas.Font.Style := [];

  x := DISTANZA_TRA_GIORNI*(Colonna-1)+MARGINE_OR+((DISTANZA_TRA_GIORNI-Lar_Testo)div 2);
  y := Riga*ALTEZZA_RIGA+MARGINE_VR+MARGINE_SOPRA;
  if (Day=Mio_Giorno)and(Mese_Corrente)then
  begin
    Disegna_Gr(3,Canvas,DISTANZA_TRA_GIORNI*(Colonna-1),y);
  end;
  Canvas.Brush.Style := bsClear;
  Canvas.TextOut(x,y,IntToStr(Day));
  if (Cor_Mese=Mio_Mese) and (Cor_anno=Mio_anno)and (Day=Cor_Giorno)and(Mese_Corrente)then
  begin
    Disegna_Gr(1,Canvas,DISTANZA_TRA_GIORNI*(Colonna-1),y);
  end;
  Inc(Colonna);
  if (Colonna=8) then
  begin
    inc(riga);
    Colonna := 1;
  end;
end;

(******************************************************************************
 * Disegna_Gr                                                                 *
 ******************************************************************************)
Procedure TACCalendar.Disegna_Gr(gr:Integer;Cnv:TCanvas;x,y:Integer);
Begin
//  x := (x * Screen.PixelsPerInch) div DPI_SCHERMOBASE;
//  y := (y * Screen.PixelsPerInch) div DPI_SCHERMOBASE;
//*********
  if (gr=1) then
  begin
    Cnv.Pen.Color := clRed;
    Cnv.Pen.Width := 3;
    Cnv.Brush.Style := bsClear;
    Cnv.Ellipse(x+3*Screen.PixelsPerInch div DPI_SCHERMOBASE,
                y+2*Screen.PixelsPerInch div DPI_SCHERMOBASE,
                x+(20+3)*Screen.PixelsPerInch div DPI_SCHERMOBASE,
                y+(10+1)*Screen.PixelsPerInch div DPI_SCHERMOBASE);
    Cnv.Brush.Style := bsSolid;
    Cnv.Pen.Width := 1;
(*    exit;
    Cnv.MoveTo(x+03*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+01);
    Cnv.LineTo(x+15*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+01);

    Cnv.MoveTo(x+03*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+02);
    Cnv.LineTo(x+19*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+02);

    Cnv.MoveTo(x+14*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+03);
    Cnv.LineTo(x+21*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+03);

    Cnv.MoveTo(x+09*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+04);
    Cnv.LineTo(x+14*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+04);
    Cnv.MoveTo(x+18*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+04);
    Cnv.LineTo(x+23*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+04);

    Cnv.MoveTo(x+06*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+05);
    Cnv.LineTo(x+14*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+05);
    Cnv.MoveTo(x+20*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+05);
    Cnv.LineTo(x+24*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+05);

    Cnv.MoveTo(x+05*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+06);
    Cnv.LineTo(x+10*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+06);
    Cnv.MoveTo(x+22*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+06);
    Cnv.LineTo(x+24*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+06);

    Cnv.MoveTo(x+04*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+07);
    Cnv.LineTo(x+07*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+07);
    Cnv.MoveTo(x+23*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+07);
    Cnv.LineTo(x+24*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+07);

    Cnv.MoveTo(x+04*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+08);
    Cnv.LineTo(x+06*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+08);
    Cnv.MoveTo(x+23*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+08);
    Cnv.LineTo(x+24*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+08);

    Cnv.MoveTo(x+04*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+09);
    Cnv.LineTo(x+05*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+09);
    Cnv.MoveTo(x+23*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+09);
    Cnv.LineTo(x+24*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+09);

    Cnv.MoveTo(x+04*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+10);
    Cnv.LineTo(x+06*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+10);
    Cnv.MoveTo(x+22*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+10);
    Cnv.LineTo(x+24*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+10);

    Cnv.MoveTo(x+04*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+11);
    Cnv.LineTo(x+09*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+11);
    Cnv.MoveTo(x+19*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+11);
    Cnv.LineTo(x+24*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+11);

    Cnv.MoveTo(x+05*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+12);
    Cnv.LineTo(x+23*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+12);

    Cnv.MoveTo(x+08*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+13);
    Cnv.LineTo(x+20*Screen.PixelsPerInch div DPI_SCHERMOBASE,y+13);*)
  End;
//*********
  if (gr=2) then
  begin
    Cnv.Pen.Color := ClBlack;
    Cnv.MoveTo(7,3);
    Cnv.LineTo(7,3);
    Cnv.MoveTo(6,4);
    Cnv.LineTo(7,4);
    Cnv.MoveTo(5,5);
    Cnv.LineTo(7,5);
    Cnv.MoveTo(6,6);
    Cnv.LineTo(7,6);
    Cnv.MoveTo(7,7);
    Cnv.LineTo(7,7);

  End;
//*********
  if (gr=3) then
  begin
    Cnv.Pen.Color := ClSilver;
    Cnv.Brush.Color := ClSilver;
    Cnv.Ellipse(x+3*Screen.PixelsPerInch div DPI_SCHERMOBASE,
                y+2*Screen.PixelsPerInch div DPI_SCHERMOBASE,
                x+(20+3)*Screen.PixelsPerInch div DPI_SCHERMOBASE,
                y+(10+1)*Screen.PixelsPerInch div DPI_SCHERMOBASE);
    Cnv.Brush.Color := clWindow;
  End;

End;

(******************************************************************************
 * Disegna_Bordo                                                              *
 ******************************************************************************)
Procedure TACCalendar.Disegna_Bordo;
Begin
//********* Bordo *********
  Canvas.Pen.Color  := clGray;
  Canvas.MoveTo(0,0);
  Canvas.LineTo(0,Height);

  Canvas.Pen.Color  := clBlack;
  Canvas.MoveTo(1,1);
  Canvas.LineTo(1,Height);

  Canvas.Pen.Color  := clWhite;
  Canvas.MoveTo(2,2);
  Canvas.LineTo(2,Height-2);

  Canvas.Pen.Color  := clGray;
  Canvas.MoveTo(0,0);
  Canvas.LineTo(Width,0);

  Canvas.Pen.Color  := clBlack;
  Canvas.MoveTo(1,1);
  Canvas.LineTo(Width-1,1);

  Canvas.Pen.Color  := clWhite;
  Canvas.MoveTo(2,2);
  Canvas.LineTo(Width-2,2);

  Canvas.Pen.Color  := clWhite;
  Canvas.MoveTo(0,Height-1);
  Canvas.LineTo(Width,Height-1);

  Canvas.Pen.Color  := $00DFDFDF;
  Canvas.MoveTo(1,Height-2);
  Canvas.LineTo(Width-1,Height-2);

  Canvas.Pen.Color  := clSilver;
  Canvas.MoveTo(2,Height-3);
  Canvas.LineTo(Width-2,Height-3);

  Canvas.Pen.Color  := clWhite;
  Canvas.MoveTo(Width-1,0);
  Canvas.LineTo(Width-1,Height-1);

  Canvas.Pen.Color  := $00DFDFDF;
  Canvas.MoveTo(Width-2,1);
  Canvas.LineTo(Width-2,Height-2);

  Canvas.Pen.Color  := clSilver;
  Canvas.MoveTo(Width-3,2);
  Canvas.LineTo(Width-3,Height-3);

End;

(******************************************************************************
 * Mouse_down                                                                 *
 ******************************************************************************)
Procedure TACCalendar.Mouse_Down(Var msg:TMessage);
Var xx,yy   : Integer;
    Riga, Colonna, Numero  : Integer;
Begin

  Btn3.Visible := False;
  Btn4.Visible := False;

  xx := LOWORD(msg.lParam);
  yy := HIWORD(msg.lParam);

//********* In fondo sulla data di "oggi" ********
  if (yy>TOP_OGGI) then
  begin
    Lock_Update := True;
    Giorno := Cor_Giorno;
    Mese   := Cor_Mese;
    Lock_Update := False;
    Anno   := Cor_Anno;

  end
//********* Su un giorno ********
  Else if (yy<TOP_OGGI)and(yy>MARGINE_VR+MARGINE_SOPRA)then
  begin
    Riga := (yy - MARGINE_VR-MARGINE_SOPRA) div ALTEZZA_RIGA;
    Colonna := (xx-MARGINE_OR) div DISTANZA_TRA_GIORNI+1;
    Numero := (Riga-1) * 7 + Colonna - Giorni_pre;
    if (Numero<1) then
    begin
      Lock_Update := True;
      Numero := Get_Numero_Giorni(Mese-1,Anno)+Numero;

      if (Mese=1) then
      begin
        Mese := 12;
        Anno := Anno - 1;
      End
      Else Mese := Mese-1;
      Lock_Update := False;
    End;

    if (Numero>Get_Numero_Giorni(Mese,Anno)) then
    begin
      Lock_Update := True;
      Numero := Numero-Get_Numero_Giorni(Mese,Anno);

      if (Mese=12) then
      begin
        Mese := 1;
        Anno := Anno + 1;
      End
      else Mese := Mese+1;
      Lock_Update := False;
    End;

    Giorno := Numero;
//    if (
//    DISTANZA_TRA_GIORNI*(Colonna-1)+MARGINE_OR+((DISTANZA_TRA_GIORNI-Lar_Testo)div 2)

//    Application.MessageBox(pchar('Riga'+IntToStr(Numero)), 'Message Box', mb_OKCancel +
//    mb_DefButton1);
    if (Assigned(OnDateClick)) then OnDateClick(Self);
  end;



  Inherited;
End;

(******************************************************************************
 * Set_Mio_Giorno                                                             *
 ******************************************************************************)
Procedure TACCalendar.Set_Mio_Giorno(Num:Word);
Begin
  if (Num>0)and(Num<=Get_Numero_Giorni(Mese,Anno)) then
  Begin
    Mio_Giorno := Num;
    if (Not Lock_Update) then Disegna_Finestra(False);
  End;
End;

(******************************************************************************
 * Set_Mio_Mese                                                               *
 ******************************************************************************)
Procedure TACCalendar.Set_Mio_Mese(Num:Word);
Begin
  if (Num>0)and(Num<13) then
  Begin
    Mio_Mese := Num;
    if (Not Lock_Update) then Disegna_Finestra(False);
  End;
End;

(******************************************************************************
 * Set_Mio_Anno                                                               *
 ******************************************************************************)
Procedure TACCalendar.Set_Mio_Anno(Num:Word);
Begin
  if (Num>0) then
  Begin
    Mio_Anno := Num;
    if (Not Lock_Update) then Disegna_Finestra(False);
  End;
End;

(******************************************************************************
 * Set_Null                                                                   *
 ******************************************************************************)
Procedure TACCalendar.Set_Null(Index:Integer;Num:Word);
Begin
End;

(******************************************************************************
 * Get_Now                                                                    *
 ******************************************************************************)
Function TACCalendar.Get_Now(Index:Integer):Word;
Var Res : Integer;
    f_anno,
    f_mese,
    f_giorno : Word;

Begin
  Res := 0;
  DecodeDate(Now,f_Anno,f_Mese,f_Giorno);
  Case index of
  0: Res := f_Giorno;
  1: Res := f_Mese;
  2: Res := f_Anno;
  End;
  Get_Now := Res;
End;

(******************************************************************************
 * Key_Down                                                                   *
 ******************************************************************************)
Procedure TACCalendar.Key_Down(Var msg:TMessage);
Var ch : Char;
Begin
 Ch := Chr(msg.wParam);
 if (ch='a') then
 Begin
   Giorno := Giorno - 1;
 End;
End;

(******************************************************************************
 * OnMenuSelectMese                                                           *
 ******************************************************************************)
Procedure TACCalendar.OnMenuSelectMese(Sender:Tobject);
Begin
  Mese := TMenuItem(Sender).Tag
end;

(******************************************************************************
 * Get_Const                                                                  *
 ******************************************************************************)
Function TACCalendar.Get_Const(Index:Integer):Integer;
Var x : Integer;
Begin
  x := 0;
  case index of
   1: x := 23; // DISTANZA_TRA_GIORNI
   2: x := 2;  // MARGINE_OR
   3: x := 2;  // MARGINE_VR
   4: x := 15; // ALTEZZA_RIGA
   5: x := 30; // MARGINE_SOPRA
   6: x := 30+12+2; //MARGINE_SOPRA+12+MARGINE_VR; // TOP_LINEA
   7: x := 138; // TOP_OGGI
   8: x := 9;   // POSY_TITOLO
   9: x := 35;  // LEFT_OGGI
  10: x := 30;  // LEFT_OGGI
  End;
  X := (X*Screen.PixelsPerInch) div DPI_SCHERMOBASE;
  Get_Const := x;
End;

(******************************************************************************
 * Vai_Oggi                                                                   *
 ******************************************************************************)
Procedure TACCalendar.Vai_Oggi;
Var// Res : Integer;
    f_anno,
    f_mese,
    f_giorno : Word;

Begin
//  Res := 0;
  DecodeDate(Now,f_Anno,f_Mese,f_Giorno);
  Lock_Update := True;
  Giorno      := f_Giorno;
  Mese        := f_Mese;
  Lock_Update := False;
  Anno        := f_Anno;
End;

(******************************************************************************
 * Interface                                                                  *
 ******************************************************************************)
procedure TACCalendar.Titolo_MouseDown(Sender: TObject; Button: TMouseButton;
                               Shift: TShiftState; X, Y: Integer);
//Var
    //Riga, Colonna, Numero  : Integer;
Begin

//********* Sul numero dell'anno *********
  if (x>TITOLO_DX) and (x<btn2.Left)  then
  begin
    Btn3.Visible := True;
    Btn4.Visible := True;
    exit;
  end;
  Btn3.Visible := False;
  Btn4.Visible := False;

//  if (xx>=TITOLO_SX) and (xx<=TITOLO_DX) and (yy>=POSY_TITOLO) and (yy<=POSY_TITOLO+Altezza_Titolo) then
///  begin
    With ClientToScreen(Point(TITOLO_SX,POSY_TITOLO+Altezza_Titolo)) Do
       Sub_Menu.PopUp(x,y);
//  end

End;

end.
