(******************************************************************************
 * ACDialogEngine                                                             *
 *                                                                            *
 * Mercoled, 14/10/1998                                                      *
 * -------------------------------------------------------------------------- *
 *            La funzione di disegno del bordo della finestra  stata         *
 *            eliminata, al suo posto  stata usata "FRAMERGN"                *
 *                                                                            *
 * Marted, 13 Aprile 2004                                                    *
 * -------------------------------------------------------------------------- *
 * La regione della finestra viene cancellata solo quando si crea una nuova   *
 * regione o quando l'oggetto viene distrutto                                 *

 ******************************************************************************)
 unit ACDialogEngine;

(******************************************************************************
 * interface                                                                  *
 ******************************************************************************)
interface

(******************************************************************************
 * uses                                                                       *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

(******************************************************************************
 * type                                                                       *
 ******************************************************************************)
type
  ACDEPosition = (ACDETopLeft,
                  ACDETopRight,
                  ACDETopCenter,
                  ACDEBottomLeft,
                  ACDEBottomRight,
                  ACDEBottomCenter,
                  ACDELeftTop,
                  ACDERightTop,
                  ACDELeftBottom,
                  ACDERightBottom);
  TACDialogEngine = class(TCustomPanel)//TComponent)
  private
    { Private declarations }
    F_Style : ACDEPosition;
  protected
    { Protected declarations }
    h_regione1,
    h_regione2,
    h_regione3 : HRgn;
    procedure Set_Style(V:ACDEPosition);
    procedure paint;override;

  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Disegna;
    property OnExit;

  published
    { Published declarations }
    Property Color;
    property Style : ACDEPosition Read F_Style Write Set_Style;
  end;

(******************************************************************************
 * implementation                                                             *
 ******************************************************************************)
implementation


(******************************************************************************
 * constructor                                                                *
 ******************************************************************************)
constructor TACDialogEngine.Create(AOwner: TComponent);
begin
 Inherited;
 h_regione1  := 0;
 Color       := clInfoBk;
 Left        := 0;
 Top         := 0;
 if (Parent <> nil) and not(Parent is TForm) then
   raise EInvalidOperation.Create('A TACDialogEngine can only placed in a Form');

 Align := alClient;

end;

(******************************************************************************
 * Destroy                                                                    *
 ******************************************************************************)
destructor TACDialogEngine.Destroy;
begin
  if (h_regione1>0) then DeleteObject(h_regione1);
  inherited Destroy;
end;

(******************************************************************************
 * Disegna                                                                    *
 ******************************************************************************)
procedure TACDialogEngine.Disegna;
Const CURVA = 20;
type
    PPoints = ^TPoints;
    TPoints = array[0..0] of TPoint;
var //hr : TRect;

    punti   : Array [0..2] of tpoint;
    Frm     : TForm;
    T,L,W,H : Integer; // Top, Left, Width, height
begin

// if (ComponentState=[csDesigning]) then exit;

 L := 0;
 T := 0;
 W := 0;
 H := 0;
 Frm := TForm(Owner);
 Frm.BorderStyle := bsNone;
 Frm.FormStyle   := fsStayOnTop;
 Case Style of
//********** ACDETopLeft **********
 ACDETopLeft:
  begin
   L := 0;
   T := Curva;
   W := Frm.Width;
   H := Frm.Height;
   Punti[0].x := 20;
   Punti[0].y := 20;
   Punti[1].x := 20;
   Punti[1].y := 00;
   Punti[2].x := 30;
   Punti[2].y := 20;

  End;
//********** ACDETopRight **********
  ACDETopRight:
  begin
   L := 0;
   T := CURVA;
   W := frm.width;
   H := frm.Height;
   Punti[0].x:= frm.width-20;
   Punti[0].y:= 20;
   Punti[1].x:= frm.width-20;
   Punti[1].y:= 00;
   Punti[2].x:= frm.width-30;
   Punti[2].y:= 20;
  End;
//********** ACDETopCenter **********
  ACDETopCenter:
  begin
   L := 0;
   T := CURVA;
   W := frm.width;
   H := frm.Height;
   Punti[0].x:= (frm.width div 2)-20;
   Punti[0].y:= 20;
   Punti[1].x:= (frm.width div 2)-20;
   Punti[1].y:= 00;
   Punti[2].x:= (frm.width div 2)-30;
   Punti[2].y:= 20;
  End;

//********** ACDEBottomLeft **********
  ACDEBottomLeft:
  begin
   L := 0;
   T := 0;
   W := frm.width;
   H := frm.Height-CURVA;
   Punti[0].x:= 20;
   Punti[0].y:= frm.Height-20-1;
   Punti[1].x:= 20;
   Punti[1].y:= frm.Height-1;
   Punti[2].x:= 30;
   Punti[2].y:= frm.Height-20-1;
  End;
//********** ACDEBottomRight **********
  ACDEBottomRight:
  begin
   L := 0;
   T := 0;
   W := frm.width;
   H := frm.Height-CURVA;
   Punti[0].x:= frm.width-20;
   Punti[0].y:= frm.Height-20-1;
   Punti[1].x:= frm.width-20;
   Punti[1].y:= frm.Height-00-1;
   Punti[2].x:= frm.width-30;
   Punti[2].y:= frm.Height-20-1;
  End;
//********** ACDEBottomCenter **********
  ACDEBottomCenter:
  begin
   L := 0;
   T := 0;
   W := frm.width;
   H := frm.Height-CURVA;
   Punti[0].x:= (frm.Width div 2)-20;
   Punti[0].y:= frm.Height-20-1;
   Punti[1].x:= (frm.Width div 2)-20;
   Punti[1].y:= frm.Height-00-1;
   Punti[2].x:= (frm.Width div 2)-30;
   Punti[2].y:= frm.Height-20-1;
  End;

//********** ACDELeftTop **********
  ACDELeftTop:
  begin
   L := CURVA;
   T := 0;
   W := frm.width;
   H := frm.Height;
   Punti[0].x:= 20;
   Punti[0].y:= 20;
   Punti[1].x:= 00;
   Punti[1].y:= 20;
   Punti[2].x:= 20;
   Punti[2].y:= 30;
  End;
//********** ACDELeftBottom **********
  ACDELeftBottom:
  begin
   L := CURVA;
   T := 0;
   W := frm.width;
   H := frm.Height;
   Punti[0].x:= 20;
   Punti[0].y:= frm.height-20;
   Punti[1].x:= 00;
   Punti[1].y:= frm.height-20;
   Punti[2].x:= 20;
   Punti[2].y:= frm.height-30;
  End;

//********** ACDERightTop **********
  ACDERightTop:
  begin
   L := 0;
   T := 0;
   W := frm.width-CURVA;
   H := frm.Height;
   Punti[0].x:= frm.width-20-1;
   Punti[0].y:= 20;
   Punti[1].x:= frm.width-00-1;
   Punti[1].y:= 20;
   Punti[2].x:= frm.width-20-1;
   Punti[2].y:= 30;
  End;
//********** ACDERightBottom **********
  ACDERightBottom:
  begin
   L := 0;
   T := 0;
   W := frm.width-CURVA;
   H := frm.Height;
   Punti[0].x:= frm.width-20-1;
   Punti[0].y:= frm.height-20-1;
   Punti[1].x:= frm.width-00-1;
   Punti[1].y:= frm.height-20-1;
   Punti[2].x:= frm.width-20-1;
   Punti[2].y:= frm.height-30-1;
  End;

 end;
//********** Imposta forma finestra *********
 if (h_regione1>0) then DeleteObject(h_regione1);
 h_regione1  := CreateRectRgn(0, 0, 0, 0);

 h_regione2 := CreateRoundRectRgn(L, T, W, H, CURVA, CURVA);
 h_regione3 := CreatePolygonRgn(PPoints(@Punti)^, 3,ALTERNATE);
 CombineRgn(h_regione1, h_regione2, h_regione3, RGN_OR);
 SetWindowRgn(frm.handle, h_regione1,true);
 canvas.brush.style := bsSolid;
 Canvas.Brush.Color := clBlack;
 DeleteObject(h_regione2);
 DeleteObject(h_regione3);

//********** Crea bordo **********

 h_regione1  := CreateRectRgn(0, 0, 0, 0);
 h_regione2 := CreateRoundRectRgn(L, T, W, H, CURVA, CURVA);
 h_regione3 := CreatePolygonRgn(PPoints(@Punti)^, 3,ALTERNATE);
 CombineRgn(h_regione1, h_regione2, h_regione3, RGN_OR);
 FrameRgn(Canvas.Handle,
          h_regione1,
          canvas.brush.handle,
          1,1);
 DeleteObject(h_regione2);
 DeleteObject(h_regione3);

end;

(******************************************************************************
 * Set_Style                                                                  *
 ******************************************************************************)
procedure TACDialogEngine.Set_Style(V:ACDEPosition);
begin
  F_Style := v;
  Invalidate;
  Disegna;
end;

(******************************************************************************
 * Paint                                                                      *
 ******************************************************************************)
procedure TACDialogEngine.paint;
begin
  inherited;
  disegna;
End;

end.
