(******************************************************************************
 * ACTrStaticLabel                                                            *
 ******************************************************************************)
unit ACTrStaticLabel;

(******************************************************************************
 * interface                                                                  *
 ******************************************************************************)
 interface

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ACTrLabel;

(******************************************************************************
 * Type                                                                       *
 ******************************************************************************)
type
  TACTrStaticLabel = class(TWinControl)
  private
    { Private declarations }
    Clr1      : TColor;
    Clr2      : TColor;
    FCaption  : String;
    FFont     : Tfont;
    FAutoSize : Boolean;
    in_cambio : Boolean;
    Lbl : TACTrLabel;
  protected


    { Protected declarations }
    Procedure SetColor1(x:Tcolor);
    Procedure SetColor2(x:TColor);
    Procedure Set_Caption(x:String);
    Procedure Set_TFont(x:TFont);
    Procedure Dimensione(Var msg:TMessage); message WM_SIZE;
    Procedure Set_AutoSize(x:Boolean);
    Procedure AutoSize_Dimensione;

  public
    { Public declarations }
    constructor Create(AOwner: TComponent); Override;
    destructor Destroy; Override;
  published
    { Published declarations }
    property Color_Start : TColor  Read Clr1      Write SetColor1;
    property Color_End   : TColor  Read Clr2      Write SetColor2;
    Property Caption     : String  Read FCaption  Write Set_Caption;
    Property Font        : TFont   Read FFont     Write Set_TFont;
    Property AutoSize    : Boolean Read FAutoSize Write Set_AutoSize;

  end;


(******************************************************************************
 *  Implementation                                                            *
 ******************************************************************************)
implementation

(******************************************************************************
 *  Free                                                                      *
 ******************************************************************************)
destructor TACTrStaticLabel.Destroy;
Begin
  FFont.Free;
  Lbl.Free;
  Inherited;
end;

(******************************************************************************
 * Create                                                                     *
 ******************************************************************************)
constructor TACTrStaticLabel.Create(AOwner: TComponent);
Begin
  Inherited;
  Lbl              := TACTrLabel.Create(self);
  FFont            := TFont.Create;
  Lbl.Parent       := Self;
  //Lbl.Align        := alClient;
  Lbl.Top            := 0;
  Lbl.Left           := 0;

  Width            := 50;
  Height           := 50;

  Caption          := 'Caption';
  Color_Start      := clYellow;
  Color_End        := clBlue;

  in_cambio        := False;
End;


(******************************************************************************
 *  Set Colori                                                                *
 ******************************************************************************)
Procedure TACTrStaticLabel.SetColor1(x:Tcolor);
Begin
  Clr1             := x;
  Lbl.Color_Start  := x;
End;

(******************************************************************************
 *                                                                            *
 ******************************************************************************)
Procedure TACTrStaticLabel.SetColor2(x:TColor);
Begin
  Clr2       := x;
  Lbl.Color_End := x;
End;

(******************************************************************************
 * Set Caption                                                                *
 ******************************************************************************)
Procedure TACTrStaticLabel.Set_Caption(x:String);
Begin
  FCaption    := x;
  Lbl.Caption := x;
  AutoSize_Dimensione;

End;

(******************************************************************************
 *  Set TFont                                                                 *
 ******************************************************************************)
Procedure TACTrStaticLabel.Set_TFont(x:TFont);
Begin
  FFont.Assign(x);
  Lbl.Font.Assign(x);
  AutoSize_Dimensione;

End;


(******************************************************************************
 * Set Autosize                                                               *
 ******************************************************************************)
Procedure TACTrStaticLabel.Set_AutoSize(x:Boolean);
Begin
  FAutoSize := x;
  Lbl.AutoSize := x;
  AutoSize_Dimensione;

End;

(******************************************************************************
 *  Autosize Dimensione                                                       *
 ******************************************************************************)
Procedure TACTrStaticLabel.AutoSize_Dimensione;
Begin
  in_cambio := True;
  if(autoSize=true) then
  begin
    lbl.Refresh;

    Width := lbl.Width;
    Height := lbl.Height;
  end
  else
  begin
    lbl.Refresh;
    lbl.Width := Width;
    lbl.Height := Height;

  end;
  in_cambio := False;

End;

(******************************************************************************
 * Dimensione                                                                 *
 ******************************************************************************)
Procedure TACTrStaticLabel.Dimensione(Var msg:TMessage);
Begin
  Inherited;
  if (in_cambio) then exit;
  if(Width<>Lbl.Width) then Lbl.Width := Width;
  if(Height<>Lbl.Height) then Lbl.Height := Height;
End;

end.
