(******************************************************************************
 * ACTransparentImage                                                         *
 *                                                                            *
 *                                                                            *
 * Sabato,29/08/1998                                                          *
 *   E' Stato aggiunto la propriet "BackIsBmp" che permette di avere         *
 *   una bitmap sotto l'immagine, purtroppo la visualizzazione nel caso in    *
 *   cui si sceglie di usare questa funzione risulta lenta.                   *
 ******************************************************************************)
unit ACTransparentImage;

(******************************************************************************
 * Interface                                                                  *
 ******************************************************************************)
 interface

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls{$ifdef AC_DEBUG_MODE} ,AC_Debug_Unit{$endif};

(******************************************************************************
 * TACTransparentImage                                                        *
 ******************************************************************************)
type
  TACTransparentImage = class(TGraphicControl)
  private
    { Private declarations }
    FColore         : TColor;
    Ftras           : boolean;
    FBMP            : TBitMap;
    F_BackIsBmp     : Boolean;
  protected
    { Protected declarations }
    procedure SetBitMap(V : TBitMap);
    Procedure SetBackIsBmp(F:Boolean);
    procedure Set_FColore(C:TColor);
    procedure Set_F_Tras(V:Boolean);
  public
    { Public declarations }

    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure paint;Override;
  published
    { Published declarations }
    property TransparentColor : TColor Read Fcolore Write Set_FColore;
                                (* indica il colore di trasparenza *)
    Property Transparent      : Boolean read Ftras Write Set_F_TRas;
                                (* Indica se l'immagine deve essere o no *)
                                (* trasparente                           *)
    Property BackIsBmp        : Boolean Read F_BackIsBmp Write SetBackIsBmp;
                                (* indica se dietro l'immagine  presente o *)
                                (* no un'altra Bmp                          *)
    Property BitMap           : TBitMap Read FBmp Write SetBitMap;
                                (* l'immagine da visualizzare *)
    Property OnClick;
  end;

(******************************************************************************
 * Implementation                                                             *
 ******************************************************************************)
implementation


(******************************************************************************
 * paint                                                                      *
 ******************************************************************************)
procedure TACTransparentImage.paint;
Var
  Rect1,
  Rect2 : TRect;
  c1,c2 : Integer;
  Bmp : TBitMap;
  MargineX,
  MargineY  : Integer;
//  Clr_Trasp : Integer;
Begin
  {$ifdef AC_DEBUG_MODE}
    if  not (csDesigning in ComponentState) then
    begin
        ac_debug_add_text('TACTransparentImage: Painte (ingresso)');
        ac_debug_add_text('                     Nome componente: '+Self.Name);
    end;
  {$endif}

//   inherited;
//   clr_Trasp := ColorToRGB(TransparentColor);
   if(Bitmap.height>0) then
   Begin

     MargineX := (Width - Bitmap.Width) Div 2; // Per centrare l'immagine Orizzontalmente
     MargineY := (Height - Bitmap.Height) Div 2; // Per centrare l'immagine verticalmente

///////////////     Height := Bitmap.height; (* Calcola la dimensione della bitmap *)
///////////////     Width := Bitmap.Width;
     Rect1 := Rect(0,0,Width,Height); (* prepara per copiare la bitmap *)
     Bmp := TBitMap.Create;           (* in un area di appoggio        *)
     Bmp.Width := Width;
     Bmp.Height := Height;
     Bmp.Canvas.CopyRect(Rect1,Canvas,Rect1); // Copia l'immagine delle schermo in questa area


     LockWindowUpdate(bmp.canvas.Handle);

     {$ifdef AC_DEBUG_MODE}
       if  not (csDesigning in ComponentState) then
       begin
           ac_debug_add_text('                     Dopo lockWindowUpdate');
           ac_debug_add_text('                     MargineX: '+IntToStr(MargineX););
       end;
     {$endif}

     if (Transparent) then (* in caso di immagine trasparente *)
     begin
//       Rect2 := Rect(0+MargineX,0+MargineY,Width+MargineX,Height+MargineY); (* Destinazione *)
       if(BackIsBmp=False) then (* se deve disegnare la bitmap non *)
       begin                    (* sopra ad una bitmap             *)
         Bmp.Canvas.Brush.color := Color;
         Rect1 := rect(0+MargineX,
                       0+MargineY,
                       BitMap.Width+MargineX,
                       BitMap.Height+MargineY);
         Rect2 := rect(0,0,BitMap.Width,BitMap.Height);
         bmp.canvas.BrushCopy(rect1,bitmap,Rect2,TransparentColor);
       End
       Else
       Begin
         Rect2 := Rect(0+MargineX,0+MargineY,Width+MargineX,Height+MargineY); (* Destinazione *)
         bmp.Canvas.CopyRect(Rect2,bitmap.Canvas,Rect1);
         for c1 := rect2.Left to rect2.right do
         begin
           for c2 := rect2.top to rect2.bottom do
           begin
             if (bmp.canvas.pixels[c1,c2]=TransparentColor) then
             begin
               bmp.canvas.pixels[c1,c2] := canvas.pixels[c1,c2];
             end;
           end;
         end;
       End;

     End
     Else
     Begin (* in caso di immagine che non deve essere trasparente *)
       Bmp.Canvas.Brush.color := Color;
       Rect1 := rect(0+MargineX,
                     0+MargineY,
                     BitMap.Width+MargineX,
                     BitMap.Height+MargineY);
       Rect2 := rect(0,0,BitMap.Width,BitMap.Height);
       bmp.Canvas.Brush.Style := bsSolid;
       bmp.Canvas.Brush.Color := TransparentColor;                // Forza il colore di trasparenza
       bmp.canvas.BrushCopy(rect1,bitmap,Rect2,TransparentColor); //


     End;

     Canvas.CopyRect(Rect1,Bmp.Canvas,Rect1); (* copia l'immagine a video *)
     LockWindowUpdate(0);
     Bmp.Free;
   End;

   if (ComponentState = [csDesigning]) Then
   Begin
     Canvas.Pen.Style := psDash;
     Canvas.Pen.Color := clBlack;
     Canvas.Brush.Style := bsClear;
     Canvas.Rectangle(0,0,Width,Height);
   End;
   {$ifdef AC_DEBUG_MODE}
     if  not (csDesigning in ComponentState) then
     begin
         ac_debug_add_text('                     Painte (usci6ta)');
     end;
   {$endif}

End;

(******************************************************************************
 * Create                                                                     *
 ******************************************************************************)
constructor TACTransparentImage.Create(AOwner: TComponent);
Begin
  {$ifdef AC_DEBUG_MODE}
    if  not (csDesigning in ComponentState) then
    begin
        ac_debug_add_text('TACTransparentImage: Create');
        ac_debug_add_text('                     Nome componente: '+Self.Name);
    end;
  {$endif}

  Inherited;
  Height := 40;
  Width := 40;
  BackIsBmp := False;
  FBMP := TBitMap.Create;
End;

(******************************************************************************
 * Destroy                                                                    *
 ******************************************************************************)
destructor TACTransparentImage.Destroy;
Begin
  {$ifdef AC_DEBUG_MODE}
    if  not (csDesigning in ComponentState) then
    begin
        ac_debug_add_text('TACTransparentImage: Distruttore (ingresso)');
        ac_debug_add_text('                     Nome componente: '+Self.Name);
    end;
  {$endif}

  FBMP.Free;
  Inherited;
End;

(******************************************************************************
 * SetBitMap                                                                  *
 ******************************************************************************)
procedure TACTransparentImage.SetBitMap(V : TBitMap);
begin
  {$ifdef AC_DEBUG_MODE}
    if  not (csDesigning in ComponentState) then
    begin
        ac_debug_add_text('TACTransparentImage: SetBitmap');
        ac_debug_add_text('                     Nome componente: '+Self.Name);
    end;
  {$endif}

   FBMP.Assign(V);
   Height := v.height;
   Width := v.Width;
   Invalidate;
end;

(******************************************************************************
 * Set_FColore                                                                *
 ******************************************************************************)
procedure TACTransparentImage.Set_FColore(C:TColor);
Begin
  FColore := C;
  invalidate;
End;

(******************************************************************************
 * Set_F_Tras(V:Boolean);                                                     *
 ******************************************************************************)
procedure TACTransparentImage.Set_F_Tras(V:Boolean);
Begin
  FTras := V;
  invalidate;
End;


(******************************************************************************
 * SetFBackIsBmp                                                              *
 ******************************************************************************)
Procedure TACTransparentImage.SetBackIsBmp(F:Boolean);
Begin
  F_BackIsBmp:=F;
  Invalidate;
End;
end.
