(******************************************************************************
 * AcWindow                                                                   *
 *                                                                            *
 *                                                                            *
 * Marted, 13 Aprile 2004                                                    *
 * -------------------------------------------------------------------------- *
 * La regione della finestra viene cancellata solo quando si crea una nuova   *
 * regione o quando l'oggetto viene distrutto                                 *
 ******************************************************************************)
 unit ACWindow;

(******************************************************************************
 * interface                                                                  *
 ******************************************************************************)
interface

(******************************************************************************
 * uses                                                                       *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

(******************************************************************************
 * type                                                                       *
 ******************************************************************************)
type
  TACWindow = class(TCustomPanel)//TComponent)
  private
    { Private declarations }
  protected
    { Protected declarations }

    Spessore : Integer; // Spessore del bordo della finestra
    Wnd_Clr  : TColor;
    h_regione1,
    h_regione2  : HRgn;
    procedure paint;override;
    Procedure Set_Spessore (X:Integer);
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Disegna;
    property OnExit;
    Procedure Set_Wnd_Clr (X:TColor);

  published
    { Published declarations }
    Property FrameWidth : Integer Read Spessore Write Set_Spessore;
    Property WindowColor : TColor Read Wnd_Clr Write Set_Wnd_Clr;
  end;

(******************************************************************************
 * implementation                                                             *
 ******************************************************************************)
implementation


(******************************************************************************
 * constructor                                                                *
 ******************************************************************************)
constructor TACWindow.Create(AOwner: TComponent);
begin
 Inherited;

 h_regione1 := 0;
 h_regione2 := 0;


 Left := 0;
 Top  := 0;
 FrameWidth := 1;
 if (Parent <> nil) and not(Parent is TForm) then
   raise EInvalidOperation.Create('A TACWindow can only placed in a Form');

 Align := alClient;
 WindowColor := clWindow;

end;

(******************************************************************************
 * Destroy                                                                    *
 ******************************************************************************)
destructor TACWindow.Destroy;
begin
  if (h_regione1<>0) then DeleteObject(H_Regione1);
  inherited Destroy;
end;

(******************************************************************************
 * Disegna                                                                    *
 ******************************************************************************)
procedure TACWindow.Disegna;
Const CURVA = 20;
var //hr : TRect;

    Frm     : TForm;
    T,L,W,H : Integer; // Top, Left, Width, height
begin

// if (ComponentState=[csDesigning]) then exit;
 L := 0;
 T := 0;
 Frm := TForm(Owner);
 Frm.BorderStyle := bsNone;
 Color := WindowColor;
// Frm.FormStyle   := fsStayOnTop;
//********** ACDETopLeft **********
 W := Frm.Width;
 H := Frm.Height;
//********** Imposta forma finestra *********
 if (h_regione1<>0) then DeleteObject(H_Regione1);
 h_regione1  := CreateRectRgn(0, 0, 0, 0);

 if (h_regione2<>0) then DeleteObject(H_Regione2);
 h_regione2 := CreateRoundRectRgn(L, T, W, H, CURVA, CURVA);
 CombineRgn(h_regione1, h_regione2, h_regione2, RGN_OR);
 SetWindowRgn(frm.handle, h_regione1,true);
 canvas.brush.style := bsSolid;
 Canvas.Brush.Color := clBlack;
 DeleteObject(h_regione2);
// DeleteObject(hr2);

//********** Crea bordo **********
 if (h_regione1<>0) then DeleteObject(H_Regione1);
 h_regione1  := CreateRectRgn(0, 0, 0, 0);
 h_regione2 := CreateRoundRectRgn(L, T, W, H, CURVA, CURVA);
 CombineRgn(h_regione1, h_regione2, h_regione2, RGN_OR);
 FrameRgn(Canvas.Handle,
          h_regione1,
          canvas.brush.handle,
          FrameWidth,
          FrameWidth);
 DeleteObject(h_regione2);


end;


(******************************************************************************
 * Paint                                                                      *
 ******************************************************************************)
procedure TACWindow.paint;
begin
  inherited;

  disegna;


End;

(******************************************************************************
 * Set_Spessore                                                               *
 ******************************************************************************)
Procedure TACWindow.Set_Spessore (X:Integer);
Begin
  if (X>=0) then
  begin
    Spessore := x;
    Invalidate;
  end;
End;

(******************************************************************************
 * Set_Spessore                                                               *
 ******************************************************************************)
Procedure TACWindow.Set_Wnd_Clr(X:TColor);
Begin
  Wnd_Clr := X;
  Invalidate;
End;

end.
