(******************************************************************************
 * AcAutoCompEdit                                                             *
 *                                                                            *
 *                                                                            *
 * Sabato, 06/03/2004                                                         *
 * -------------------------------------------------------------------------- *
 * Prima la ricerca delle parole chiave veniva fatta sull'evento "WM_KEYUP"   *
 * Ora viene fatta sull'evento "OnChange", metodo "Change"                    *
 *                                                                            *
 * Domenica, 18/07/2004                                                       *
 * -------------------------------------------------------------------------- *
 * Prima veniva completata solo la prima parola, ora funziona (si spera)      *
 * anche per le parola che vengono dopo e per quelle inserite in mezzo        *
 *                                                                            *
 * Domenica, 10/10/2004                                                       *
 * -------------------------------------------------------------------------- *
 * Corretto un problema, succedeva che dava un errore "control has no parent" *
 *                                                                            *
 ******************************************************************************)
unit AcAutoCompEdit;

(******************************************************************************
 * interface                                                                  *
 ******************************************************************************)
interface

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ACStrings;

(******************************************************************************
 * Type                                                                       *
 ******************************************************************************)
type
  TACAutocompEdit = class(TEdit)
  private
    { Private declarations }
    ElencoStr : TACStrings;
    In_Completamento : Boolean;
    lunghezza        : Integer;
  protected
    { Protected declarations }
    Procedure Set_ElencoStr(El:TACStrings);
    constructor Create(AOwner: TComponent); Override;
    destructor Destroy; Override;
  public
    { Public declarations }
  published
    { Published declarations }
    Property StringList : TAcStrings Read ElencoStr Write Set_ElencoStr;
    procedure change; override;
  end;


(******************************************************************************
 * implementation                                                             *
 ******************************************************************************)
implementation

(******************************************************************************
 * Set_ElencoStr                                                              *
 ******************************************************************************)
Procedure TACAutocompEdit.Set_ElencoStr(El:TACStrings);
Begin
  ElencoStr := El;
End;

(******************************************************************************
 * constructor                                                                *
 ******************************************************************************)
constructor TACAutocompEdit.Create(AOwner: TComponent);
Begin
  Inherited;
  ElencoStr := Nil;
  In_Completamento := False;
  Lunghezza        := 0; // Inzia con la stringa a 0
//  ElencoStr := TACStrings.Create(Self);
End;


(******************************************************************************
 * destructor                                                                 *
 ******************************************************************************)
destructor TACAutocompEdit.Destroy;
Begin
//  ElencoStr.Free;
  Inherited;
End;

(******************************************************************************
 * change                                                                     *
 ******************************************************************************)
procedure TACAutocompEdit.change;
Var c1,c2,c3,c4 : Integer;
    testo, Testo2, Testo3  : String;
    Lunghezza_Testo        : Integer;
    Inizio                 : Integer;
//    txt : string;
begin
  inherited;
  if (csDesigning in componentstate) or (Parent=nil) then exit;	
  if (trim(text)='') then exit;
  if (Length(text)<Lunghezza) then // Sta cancellando
  begin
    Lunghezza := length(text);
    exit;
  end;

  if (In_Completamento) Then Exit;


  Testo := Text; // Cerca l'ultima parola all'interno del testo
  Inizio := SelStart;
  if (Testo[inizio]=' ') then exit; // Se ho inserito uno spazio esco subito
  if (selStart>0) then
  begin
    if (Inizio<Length(Testo)) then // Se ci sono parole dopo le toglie
    begin
      c4 := Inizio;
      while(c4<=Length(Testo)) do
      begin
        if (Testo[c4]=' ') then break;
        c4 := c4+1;
      end;
      if (c4>1) then c4 := c4-1;
      if (c4<Length(testo)) then Testo := Copy(Testo,1,c4);

    end;

    c4    := Inizio; // Se ci sono parola prima le toglie
    while(testo[c4]<>' ') and (c4>=1) do c4 := c4-1;
    if (c4<>Inizio)and(c4>=1) then Delete(testo,1,c4)
    else if (testo[inizio]=' ') then testo := ''; // Sto iniziando una parola nuova


  end;

  In_Completamento := True;
  if (testo<>'') then
  begin
    if (Assigned(StringList)) Then
    Begin
      Lunghezza_Testo := Length(Testo);
      For c1 := 0 to StringList.Strings.Count - 1 Do
      Begin
        if (Copy(StringList.Strings[c1],1,Lunghezza_Testo)=Testo) Then
        Begin
          // Numero di caratteri da aggiungere alla parola corrente
          // Se ho scritto "CI" e la parola e' "CIAO" il numero
          // di caratteri da aggiungere e' 2
          c2 := Length(StringList.Strings[c1])-Lunghezza_Testo;

          Testo2 := StringList.Strings[c1];   // Copia la stringa completa
          Delete(Testo2,1,length(testo2)-c2); // Toglie i caratteri che sono gi stati scritti

          Testo3 := Text;
          Insert(Testo2,Testo3,Inizio+1);
          Text := Testo3;

          SelStart := Inizio;
          SelLength := c2;
          Lunghezza := length(text);//c3;
          In_Completamento := False;
          exit;
        End;
      End;
    End;
  end;
  In_Completamento := False;

end;

end.
