(******************************************************************************
 * ACUndEdit                                                                  *
 ******************************************************************************)
unit ACUndEdit;

(******************************************************************************
 * interface                                                                  *
 ******************************************************************************)
 interface

(******************************************************************************
 * uses                                                                       *
 ******************************************************************************)
 uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

(******************************************************************************
 * type                                                                       *
 ******************************************************************************)
type
  TACUndEdit = class(TEdit)
  private
    { Private declarations }
    Pnl        : TPanel;
    F_Bordo    : TColor;
    Offset     : Integer;
    In_Disegna : Boolean;
//
// Property OffSet : Integer Read F_Offset Write F_Offset;
  protected
    { Protected declarations }

    procedure Win_Paint(Var Msg : TMessage); message WM_Paint;
    procedure Win_Move(Var Msg : TMessage); message WM_Move;
//    procedure Win_Size(Var Msg : TMessage);// message WM_Size;
    procedure Ridisegna(assegna:Boolean);
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy;override;
  published
    { Published declarations }
    Property BorderColor : TColor Read F_Bordo Write F_Bordo;

  end;

(******************************************************************************
 * implementation                                                             *
 ******************************************************************************)
 implementation


(******************************************************************************
 * Win_Paint                                                                  *
 ******************************************************************************)
procedure TACUndEdit.Win_Paint(Var Msg : TMessage);
Begin
  if (Not Assigned(Pnl))or (Pnl.ComponentState=[csDestroying]) Then Exit;
  Ridisegna(True);
  inherited;
End;

(******************************************************************************
 * Win_Move                                                                   *
 ******************************************************************************)
procedure TACUndEdit.Win_Move(Var Msg : TMessage);
Begin
  if (Not Assigned(Pnl))or (Pnl.ComponentState=[csDestroying]) Then Exit;
  Ridisegna(false);
  inherited;
End;

(******************************************************************************
 * Win_Move                                                                   *
 ******************************************************************************)
//procedure TACUndEdit.Win_Size(Var Msg : TMessage);
//Begin
//  Ridisegna(False);
//  inherited;
//End;

(******************************************************************************
 * Ridisegna                                                                  *
 ******************************************************************************)
procedure TACUndEdit.Ridisegna(assegna:Boolean);
Begin
  if (In_Disegna) Then Exit;
  In_Disegna := True;
  if (borderStyle=bsSingle) then offset := 2
  else offset := 1;

  Pnl.Left        := Left;// - OffSet;
  Pnl.Top         := Top + Height + OffSet;
  Pnl.Width       := Width;// + OffSet*2;
  Pnl.Height      := 1;
  Pnl.Color       := BorderColor;

  if (Assegna) then Pnl.Parent      := Parent;
  In_Disegna := False;
End;

(******************************************************************************
 * constructor                                                                *
 ******************************************************************************)
constructor TACUndEdit.Create(AOwner: TComponent);
Begin
 Inherited;
 Pnl             := TPanel.Create(Self);
 Pnl.Brush.Style := bsClear;

 Pnl.Color       := BorderColor;
 Pnl.Visible     := True;
 Pnl.BevelInner  := bvNone;
 Pnl.BevelOuter  := bvNone;
 Pnl.BorderStyle := bsNone;
 In_Disegna      := False;
 Ridisegna(False)
End;

(******************************************************************************
 * destructor                                                                 *
 ******************************************************************************)
destructor TACUndEdit.Destroy;
Begin
//  Pnl.Free;
//  Pnl := Nil;
  Inherited;
End;

end.
