{******************************************************************************
 *                                                                            *
 ******************************************************************************}
unit Fn_Soci;

{******************************************************************************
 *                                                                            *
 ******************************************************************************}
interface

{******************************************************************************
 *                                                                            *
 ******************************************************************************}
Uses StdCtrls, Classes;

{******************************************************************************
 *                                                                            *
 ******************************************************************************}
Const SOCI_PER_SCHEDA = 7;
{******************************************************************************
 *                                                                            *
 ******************************************************************************}
Type
  aa_rec_soci = record
    Codice     : Integer;
    Nome       : String[50];
    Cognome    : String[50];
    Tutore     : String[50];
    Indirizzo  : String[50];
    Paese      : String[50];
    Cap        : String[5];
    Provincia  : String[4];
    Telefono   : String[30];
    Vari1      : String[30];
    Vari2      : String[30];
    Vari3      : String[30];

  end;
  rec_soci = record
    Codice     : Integer;
    Nome       : String[50];
    Cognome    : String[50];
    Tutore     : String[50];
    Indirizzo  : String[50];
    Paese      : String[50];
    Cap        : String[5];
    Provincia  : String[4];
    Telefono   : String[30];
    Precedente : Integer;
    Successivo : Integer;
    Cancellato : Boolean;
    Vari1      : String[30];
    Vari2      : String[30];
    Vari3      : String[30];

  end;

  sette_rec_soci = array[1..SOCI_PER_SCHEDA] of rec_soci;

{******************************************************************************
 *                                                                            *
 ******************************************************************************}
 Var
  ss_codice,
  ss_cognome,
  ss_nome,
  ss_indirizzo : array[1..SOCI_PER_SCHEDA] of TLabel;

Soci_Browse_Primo : Integer;
Soci_Corrente     : integer;


Procedure soci_Registra_Nuovo(x:rec_soci);

Procedure soci_Leggi(Var x:rec_soci;num:integer);

Procedure soci_scrivi(x:rec_soci;num:integer);

function soci_cerca(campo:String;primo_da_cercare:Integer):integer;

function soci_next_codice : integer;

function soci_Leggi_7(Var x:sette_rec_soci;num:integer):integer;

Procedure Soci_compila(app1 : rec_soci);

function soci_get_numero : integer;

procedure soci_compila_browse;

Procedure soci_Reset(var x:rec_soci);

procedure soci_set_codice_ultimo_progressivo(cod:integer);

procedure soci_carica_elenco_prestiti(Var ele:TComboBox);

function soci_cerca_per_codice(Var x:rec_soci;num:integer;Cancellati:Boolean):integer;

function soci_nome_archivio_temp:string;

function soci_scrivi_7(Var x:sette_rec_soci;num,quanti:integer;Nome:String):integer;

procedure soci_Cancella(codice:Integer);

procedure soci_recupera_dati_form(var app1 : rec_soci);

//function socio_codice_da_combo_prestiti (txt:string):integer;

function soci_cerca_full(x:rec_soci):integer;

function soci_nome_archivio:String;

function soci_get_stato_archivio:Integer;

function soci_cerca_simple(Codice:integer):Integer;

function Soci_ritorna_move(corrente,dove:integer):Integer;

function Soci_get_codice_primo:Integer;

function Soci_get_codice_ultimo:Integer;

{******************************************************************************
 *                                                                            *
 ******************************************************************************}
implementation


{******************************************************************************
 *                                                                            *
 ******************************************************************************}
Uses Vari, sysUtils, form_main;


{******************************************************************************
 * Soci Get Codice Primo                                                      *
 *                                                                            *
 * Ottiene il codice del primo libro                                          *
 ******************************************************************************}
function Soci_get_codice_primo:Integer;
Var x:rec_Soci;
begin
  Soci_Leggi(x,0);
  Soci_get_codice_primo := x.Precedente;
end;

{******************************************************************************
 * Soci Get Codice Ultimo                                                     *
 *                                                                            *
 * Ottiene il codice dell'ultimo                                              *
 ******************************************************************************}
function Soci_get_codice_ultimo:Integer;
Var x:rec_Soci;
begin
  Soci_Leggi(x,0);
  Soci_get_codice_ultimo := x.Successivo;
end;

(******************************************************************************
 *                                                                            *
 ******************************************************************************)
procedure Soci_set_codice_primo_ultimo(numero:integer;primo:boolean);
var x : rec_Soci;
    f : integer;

begin
   f := FileOpen(Soci_nome_archivio,fmOpenReadWrite);
   if (FileSeek(f, 0, 2)>0) then // Lunghezza file
   begin // Se il file non  vuoto legge il codice precedente
     FileSeek(f, 0, 0);
     FileRead(f, x, SizeOf(x));
   end
   else  // Altrimenti genera un codice nuovo
   begin
     Soci_Reset(x);
   end;
   if(primo) then x.Precedente := numero
   else x.Successivo := numero;
   FileSeek(f, 0, 0);
   FileWrite(f, x, SizeOf(x));
   FileClose(f);

end;

{******************************************************************************
 * Crea Archivio                                                              *
 ******************************************************************************}
procedure Soci_crea_Archivio(nome:string);
Var f    : Integer;
begin
  if (not fileexists(nome)) Then
  begin
    f := FileCreate(nome);
    FileClose(f);
    soci_set_codice_ultimo_progressivo(0); // Inizializza il codice
  end;
end;
{***************************************************************************
 * Soci_setta_Successivo_a                                                 *
 *                                                                         *
 * Setta il nuovo successivo di un determinato Record                      *
 ***************************************************************************}
Procedure Soci_setta_Successivo_a(Codice, nuova_dest : Integer);
Var x : rec_Soci;
Begin
  Codice := Soci_cerca_per_codice(x,Codice,False);
  if (Codice>0) then
  begin
    Soci_Leggi(x,Codice);
    x.Successivo := nuova_Dest;
    Soci_Scrivi(x,Codice);
  end;
End;

{***************************************************************************
 * Soci_setta_Precedente_a                                                 *
 *                                                                         *
 * Setta il nuovo precedente di un determinato Record                      *
 ***************************************************************************}
Procedure Soci_setta_Precedente_a(Codice, nuova_dest : Integer);
Var x : rec_Soci;
Begin
  Codice := Soci_cerca_per_codice(x,Codice,False);
  if (Codice>0) then
  begin
    Soci_Leggi(x,Codice);
    x.Precedente := nuova_Dest;
    Soci_Scrivi(x,Codice);
  end;
End;

{******************************************************************************
 *                                                                            *
 ******************************************************************************}
function soci_nome_archivio:String;
Begin
  soci_nome_archivio := completa_percorso(cur_path)+'soci\soci.dat';
end;

{******************************************************************************
 *                                                                            *
 ******************************************************************************}
function soci_nome_archivio_temp:string;
Begin
  soci_nome_archivio_temp := completa_percorso(cur_path)+'soci\soci.tmp';
end;

{******************************************************************************
 *                                                                            *
 ******************************************************************************}
Procedure soci_Reset(var x:rec_soci);
Begin
   x.Codice     := 0;
   x.Nome       := '';
   x.Cognome    := '';
   x.Tutore     := '';
   x.Indirizzo  := '';
   x.Paese      := '';
   x.Cap        := '';
   x.Provincia  := '';
   x.Telefono   := '';
   x.Precedente := -1;
   x.Successivo := -1;
   x.Cancellato := false;
   x.Vari1      := '';
   x.Vari2      := '';
   x.Vari3      := '';
End;

{******************************************************************************
 * Soci Registra Nuovo                                                        *
 *                                                                            *
 * Registra un nuovo socio                                                    *
 *                                                                            *
 *                                                                            *
 * Nome          Descrizione                                                  *
 * ------------- ------------------------------------------------------------ *
 * x             Dati del socio                                               *
 ******************************************************************************}
Procedure soci_Registra_Nuovo(x:rec_soci);
Var f : Integer;
Begin

//   Soci_crea_Archivio(0);

  if (not fileexists(soci_nome_archivio)) Then//if (not fileexists(soci_nome_archivio)) Then
  begin
    f := FileCreate(soci_nome_archivio);
    FileClose(f);
    soci_set_codice_ultimo_progressivo(0); // Inizializza il codice
  end;

  x.successivo:= x.codice;
  if (Soci_get_codice_ultimo=-1) then x.precedente:= x.codice
  else
  begin
    Soci_setta_Successivo_a(Soci_get_codice_ultimo,x.codice);
    x.precedente := Soci_get_codice_ultimo; // Setto il libro precedente
  end;

  f := FileOpen(soci_nome_archivio,fmOpenWrite);
  FileSeek(f, 0, 2); // Si posiziona alla fine
  FileWrite(f, x, SizeOf(x));
  FileClose(f);
  soci_set_codice_ultimo_progressivo(x.codice); // Registra l'ultimo codice

  soci_set_codice_ultimo_progressivo(x.codice); // Registra l'ultimo codice
  soci_set_codice_primo_ultimo(x.codice,false);
  if (soci_get_codice_primo=-1) then soci_set_codice_primo_ultimo(x.codice,True);

End;

{******************************************************************************
 * soci get numero                                                            *
 *                                                                            *
 * Restituisce il numero di soci archiviati                                   *
 ******************************************************************************}
function soci_get_numero : integer;
Var f, app1 : Integer;
Begin

   if (Fileexists(soci_nome_archivio)) then
   begin
     f := FileOpen(soci_nome_archivio,fmOpenRead);
     app1 := (FileSeek(f, 0, 2) div sizeof(rec_soci)) - 1;
     if (app1<0) then app1 := 0;
     soci_get_numero := app1 ; // Toglie il primo record che  di controllo per il programma
     FileClose(f);
   end
   else
   begin
     soci_get_numero := 0;
   end;
End;

{******************************************************************************
 * Soci leggi                                                                 *
 *                                                                            *
 *                                                                            *
 * Nome          Descrizione                                                  *
 * ------------- ------------------------------------------------------------ *
 * x             Buffer dove inserire i dati del socio                        *
 * num           Numero del record da leggere  (NON  il codice socio)        *
 ******************************************************************************}
Procedure soci_Leggi(Var x:rec_soci;num:integer);
Var f : Integer;
Begin
   //if (not fileexists(soci_nome_archivio)) Then f := FileCreate(soci_nome_archivio)

   soci_Reset(x);
   if (num<=soci_get_numero) then
   Begin
     f := FileOpen(soci_nome_archivio,fmOpenRead);
     FileSeek(f, num*SizeOf(x), 0); // Si posiziona alla fine
     FileRead(f, x, SizeOf(x));
     FileClose(f);
   end;

End;

{******************************************************************************
 * Soci scrivi                                                                *
 *                                                                            *
 *                                                                            *
 * Nome          Descrizione                                                  *
 * ------------- ------------------------------------------------------------ *
 * x             Buffer dove inserire i dati del socio                        *
 * num           Numero del record da leggere  (NON  il codice socio)        *
 ******************************************************************************}
Procedure soci_scrivi(x:rec_soci;num:integer);
Var f : Integer;
Begin
   //if (not fileexists(soci_nome_archivio)) Then f := FileCreate(soci_nome_archivio)
   if (num=0) then
      num := 1;
   if (num<=soci_get_numero) then
   Begin
     f := FileOpen(soci_nome_archivio,fmOpenWrite);
     FileSeek(f, num*SizeOf(x), 0); // Si posiziona alla fine
     FileWrite(f, x, SizeOf(x));
     FileClose(f);
   end;

End;

{******************************************************************************
 * soci leggi 7                                                               *
 *                                                                            *
 *                                                                            *
 * Nome          Descrizione                                                  *
 * ------------- ------------------------------------------------------------ *
 * x             Buffer dove inserire i dati del socio                        *
 * num           Numero del primo record da leggere  (NON  il codice socio)  *
 ******************************************************************************}
function soci_Leggi_7(Var x:sette_rec_soci;num:integer):integer;
Var f : Integer;
    c1 : integer;
Begin
   //if (not fileexists(soci_nome_archivio)) Then f := FileCreate(soci_nome_archivio)
   if (num=0) then num := 1;

   for c1 := 1 to SOCI_PER_SCHEDA do
        soci_Reset(x[c1]);
   c1 := 0; // Numero record letti
   if (num<=soci_get_numero) then
   Begin
     f := FileOpen(soci_nome_archivio,fmOpenRead);
     FileSeek(f, num*SizeOf(rec_soci), 0); // Si posiziona alla fine
     c1 := FileRead(f, x, SizeOf(rec_soci) * SOCI_PER_SCHEDA);
     c1 := c1 div sizeof(rec_soci); // Numero record letti
     FileClose(f);
   end;
   soci_Leggi_7 := c1;

End;
{******************************************************************************
 * soci_scrivi_7                                                              *
 *                                                                            *
 * Scrive fino a sette soci contemporaneamente                                *
 *                                                                            *
 * Nome        Descrizione                                                    *
 * ----------- -------------------------------------------------------------- *
 * x           Buffer                                                         *
 * Num         Numero del record (NON e' il codice del socio, ma la posizione *
 *                               nel file)                                    *
 * quanti      Quanti soci scrivere, max 7                                    *
 * Nome        Nome del file in cui scrivere i record, se  un valore nullo   *
 *             scrive nell'archivio principale                                *
 ******************************************************************************}
function soci_scrivi_7(Var x:sette_rec_soci;num,quanti:integer;Nome:String):integer;
Var f : Integer;
    c1 : integer;
Begin
    if (trim(nome)='') then nome := soci_nome_archivio;
   //if (not fileexists(book_nome_archivio)) Then f := FileCreate(book_nome_archivio)

   //dec(num);
//   for c1 := 1 to Quanti do
//        book_Reset(x[c1]);
//   c1 := 0; // Numero record letti
//   if (num<=book_get_numero) then
//   Begin
   f := FileOpen(nome,fmOpenWrite);
   FileSeek(f, num*SizeOf(rec_soci), 0); // Si posiziona alla fine
   c1 := FileWrite(f, x, SizeOf(rec_soci) * Quanti);
   c1 := c1 div sizeof(rec_soci); // Numero record letti
   FileClose(f);
//   end;
   soci_scrivi_7 := c1;
End;

{******************************************************************************
 *                                                                            *
 ******************************************************************************}
function soci_cerca(campo:String;primo_da_cercare:Integer):integer;
var Primo, c1,c2 : integer;
    app1         : rec_soci;
    fl           : Boolean;
Begin
  if (primo_da_cercare=0) then primo := 1
  else Primo := primo_da_Cercare;

  c2 := soci_get_numero;
  for c1 := Primo to c2 do
  begin

    soci_leggi(app1,c1);
    if (app1.cancellato=false) then
    begin
      fl := False;
      //fl := fl and
      fl := fl or compara_valori_simple(Campo , IntToStr(app1.codice));
      fl := fl or compara_valori_simple(Campo , app1.Nome);
      fl := fl or compara_valori_simple(Campo , app1.Cognome);
      fl := fl or compara_valori_simple(Campo , app1.Tutore);
      fl := fl or compara_valori_simple(Campo , app1.Indirizzo);
      fl := fl or compara_valori_simple(Campo , app1.Paese);
      fl := fl or compara_valori_simple(Campo , app1.Cap);
      fl := fl or compara_valori_simple(Campo , app1.Provincia);
      fl := fl or compara_valori_simple(Campo , app1.Telefono);
      if (fl) then
      Begin
        soci_cerca := c1;
        exit;
      End;
    end;
  end;
  soci_cerca := -1;
End;

{******************************************************************************
 *                                                                            *
 ******************************************************************************}
function soci_cerca_full(x:rec_soci):integer;
var c1,c2 : integer;
    app1         : rec_soci;
    fl           : Boolean;
Begin
  c2 := soci_get_numero;
  for c1 := 1 to c2 do
  begin
    soci_leggi(app1,c1);
    fl := True;
    //fl := fl and
    if (x.codice>0) then fl := fl and (x.codice=app1.codice);
    fl := fl and compara_valori_simple(x.Nome       , app1.Nome);
    fl := fl and compara_valori_simple(x.Cognome    , app1.Cognome);
    fl := fl and compara_valori_simple(x.Tutore     , app1.Tutore);
    fl := fl and compara_valori_simple(x.Indirizzo  , app1.Indirizzo);
    fl := fl and compara_valori_simple(x.Paese      , app1.Paese);
    fl := fl and compara_valori_simple(x.Cap        , app1.Cap);
    fl := fl and compara_valori_simple(x.Provincia  , app1.Provincia);
    fl := fl and compara_valori_simple(x.Telefono   , app1.Telefono);
    if (fl) then
    Begin
      soci_cerca_full := c1;
      exit;
    End;
  end;
  soci_cerca_full:= -1;
End;

{******************************************************************************
 *                                                                            *
 ******************************************************************************}
function soci_next_codice : integer;
var x : rec_soci;
Begin
  soci_Leggi(x,0);
  soci_next_codice := x.codice+1;
End;

{******************************************************************************
 *                                                                            *
 ******************************************************************************}
procedure soci_compila_browse;
var x : rec_soci;
    c1, Old, Corrente : integer;

Begin
 old := -1;
 if (Soci_Browse_Primo <=0) then Soci_Browse_Primo := Soci_get_codice_primo;
 if (Soci_Browse_Primo >=Soci_get_codice_ultimo) then Soci_Browse_Primo := Soci_get_codice_ultimo;
 Corrente := Soci_Browse_Primo;

 for c1 := 1 to SOCI_PER_SCHEDA do
 begin
   soci_Leggi(x,corrente);
   if (corrente=old)or(corrente=-1) then
   begin
     soci_reset(x);
   end;
   if (x.Codice>0) then ss_codice[c1].caption := IntToStr(x.Codice)
   else ss_codice[c1].caption := '';
   ss_cognome[c1].caption     := x.Cognome;
   ss_nome[c1].caption        := x.Nome;
   ss_indirizzo[c1].caption   := x.Indirizzo;
   Old                        := Corrente;
   Corrente := x.Successivo;
 end;

End;


(******************************************************************************
 *                                                                            *
 ******************************************************************************)
Procedure Soci_compila(app1 : rec_soci);
Begin

  form1.edCodice_soci.Text      := IntToStr(app1.codice);
  form1.edNome.Text        := app1.Nome;
  form1.edCognome.Text     := app1.Cognome;
  form1.edTutore.Text      := app1.Tutore;
  form1.edIndirizzo.Text   := app1.Indirizzo;
  form1.edPaese.Text       := app1.Paese;
  form1.edCap.Text         := app1.Cap;
  form1.edProvincia.Text   := app1.Provincia;
  Form1.edTelefono.Text    := app1.Telefono;

End;

(******************************************************************************
 *                                                                            *
 ******************************************************************************)
procedure soci_set_codice_ultimo_progressivo(cod:integer);
var x : rec_soci;
    f : integer;

begin
   f := FileOpen(soci_nome_archivio,fmOpenReadWrite);
   if (FileSeek(f, 0, 2)>0) then // Lunghezza file
   begin // Se il file non  vuoto legge il codice precedente
     FileSeek(f, 0, 0);
     FileRead(f, x, SizeOf(x));
   end
   else  // Altrimenti genera un codice nuovo
   begin
     soci_Reset(x);
   end;
   x.codice := cod;
   FileSeek(f, 0, 0);
   FileWrite(f, x, SizeOf(x));
   FileClose(f);

end;

{***************************************************************************
 *                                                                         *
 ***************************************************************************}
procedure soci_carica_elenco_prestiti(Var ele:TComboBox );
var c1,c2,primo : integer;
    soci : sette_rec_soci;
Begin
 ele.items.clear;
 c1 := 7;
 primo := 1;
 while(c1=7)do
 begin
   c1 := soci_Leggi_7(soci,primo);
   primo := primo + c1;
   for c2 := 1 to c1 do
   begin
     ele.items.Add(IntToStr(soci[c2].Codice)+': '+soci[c2].Cognome+' '+soci[c2].Nome);
   end;
 end;

end;


{******************************************************************************
 *                                                                            *
 ******************************************************************************}
function soci_cerca_per_codice(Var x:rec_soci;num:integer;Cancellati:Boolean):integer;
var primo, ultimo, corrente : integer;
    trovato : Integer;
    temp    : rec_soci;
    flag    : Boolean;
begin
  Primo := 1;
  Ultimo := soci_get_numero;
  Trovato := -1;
  while ((Primo<=Ultimo)and(trovato=-1)) do
  begin
    Corrente := (Primo+Ultimo) div 2;
    soci_Leggi(temp,corrente);
    if (temp.codice=num) then
    begin
      if(Cancellati) then Flag := True
      else Flag := Not temp.cancellato;

      x := temp;
      if (flag) then Trovato := corrente
      else Break;

    end
    else
    begin
      if (temp.codice<num) then primo := corrente+1
      else if (temp.codice>num) then ultimo := corrente-1
    end
  end;
  soci_cerca_per_codice := Trovato;
end;

{******************************************************************************
 *                                                                            *
 ******************************************************************************}
procedure soci_Cancella(codice:Integer);
var 
    app1  : rec_soci;

    cercato       : Integer;
begin
  Cercato := soci_cerca_simple(Codice);
  soci_Leggi(app1,Cercato);
  App1.Cancellato := True;
  soci_Scrivi(app1,Cercato);


  if (Codice<=soci_get_codice_primo)or(App1.Codice=app1.Precedente) then // Se e' il primo
  begin
    if (Codice>=soci_get_codice_ultimo) then // se e' un record unico
    begin
      soci_set_codice_primo_ultimo(-1,false);
      soci_set_codice_primo_ultimo(-1,true);
    end
    else
    begin
      soci_set_codice_primo_ultimo(app1.successivo,true);
      soci_setta_Precedente_a(App1.Successivo, App1.Successivo);
    end;
  end
  else if (Codice>=soci_get_codice_ultimo)or(App1.Codice=app1.Successivo) then // Se e' l'ultimo
  begin
    if (Codice<=soci_get_codice_primo) then // se e' un record unico
    begin
      soci_set_codice_primo_ultimo(-1,false);
      soci_set_codice_primo_ultimo(-1,true);
    end
    else
    begin
      soci_set_codice_primo_ultimo(app1.precedente,false);
      soci_setta_Successivo_a(App1.Precedente, App1.Precedente);
    end;
  end
  else  // Altrimenti
  begin
    soci_setta_Successivo_a(App1.Precedente, App1.Successivo);
    soci_setta_Precedente_a(App1.Successivo, App1.Precedente);
  end;
end;

{******************************************************************************
 *                                                                            *
 ******************************************************************************}
procedure soci_recupera_dati_form(var app1 : rec_soci);
begin
  app1.Codice     := aTOi(form1.edCodice_soci.Text);
  app1.Nome       := form1.edNome.Text;
  app1.Cognome    := form1.edCognome.Text;
  app1.Tutore     := form1.edTutore.Text;
  app1.Indirizzo  := form1.edIndirizzo.Text;
  app1.Paese      := form1.edPaese.Text;
  app1.Cap        := form1.edCap.Text;
  app1.Provincia  := form1.edProvincia.Text;
  app1.Telefono   := form1.edTelefono.Text;

end;

{******************************************************************************
 *                                                                            *
 ******************************************************************************}
//function socio_codice_da_combo_prestiti (txt:string):integer;
//var c1 : integer;
//begin
//  c1 := pos(':',txt);
//  if (c1>0) then
//  begin
//    txt := copy(txt,1,c1-1);
//  end
//  else
//  begin
//    txt := '0';
//  end;
//  socio_codice_da_combo_prestiti := aTOi(txt);
//
//
//end;


{******************************************************************************
 *                                                                            *
 ******************************************************************************}
function soci_get_stato_archivio:Integer;
begin
  soci_get_stato_archivio := stato_file(soci_Nome_Archivio);
End;

{******************************************************************************
 *                                                                            *
 ******************************************************************************}
function soci_cerca_simple(Codice:integer):Integer;
Var app : rec_soci;

Begin
  soci_cerca_simple := soci_cerca_per_codice(app,codice,True);
End;

(******************************************************************************
 * Soci_ritorna_move                                                          *
 *                                                                            *
 * Nome      Descrizione                                                      *
 * --------- ---------------------------------------------------------------- *
 * Corrente  Codice corrente                                                  *
 * dove      -1 Ritorna il codice del socio precedente                        *
 *           +1 Ritorna il codice del socio successivo                        *
 ******************************************************************************)
function Soci_ritorna_move(corrente,dove:integer):Integer;
Var r1 : Integer;
    app1 : Rec_Soci;
begin
  r1 := Corrente;
  Soci_Leggi(app1,Soci_cerca_simple(Corrente));
  if (dove=+1) then r1:=App1.Successivo
  else if (dove=-1) then r1:=App1.Precedente;
  Soci_ritorna_move := r1;
end;

end.



