{***************************************************************************
 *                                                                         *
 ***************************************************************************}
unit vari;

{***************************************************************************
 *                                                                         *
 ***************************************************************************}
interface

function completa_percorso(txt:String):String;
function CUR_PATH : String;
function compara_valori(v1,v2 : string):Boolean;
function compara_valori_simple(v1,v2 : string):Boolean;

Function aTOi(Num:String):Integer;
Function Format_Str(Txt:String;Lunghezza:Integer;Destra:Boolean):String;
function  codifica_stringa(txt1:string) : string;
function  get_codifica_stringa(var txt1:string) : string;
Function GetColorPlanesNumber : Integer;
function stato_file(x:String):Integer;
function crea_percorsi : integer;
{***************************************************************************
 *                                                                         *
 ***************************************************************************}
implementation
(******************************************************************************
 *                                                                            *
 ******************************************************************************)
uses Sysutils, Forms, Windows;

{***************************************************************************
 *                                completa_percorso                        *
 ***************************************************************************}
function completa_percorso(txt:String):String;
Begin
  if (Txt[Length(Txt)]<>'\') then Txt := Txt + '\';
  completa_percorso := Txt;
End;

{***************************************************************************
 *                                    Cur_path                             *
 ***************************************************************************}
function CUR_PATH : String;
Var Txt : String;
Begin
  txt := ExtractFilePath(application.ExeName);
  Cur_Path := completa_percorso(Txt);
end;

{***************************************************************************
 * Compara Valori                                                          *
 ***************************************************************************}
function compara_valori(v1,v2 : string):Boolean;
var fl : Boolean;
Begin
  fl := True;
  v1 := UpperCase(Trim(v1));
  v2 := UpperCase(Trim(v2));
  if(v1<>'') Then
  Begin
    fl := v1=v2;
  End;
  compara_valori := fl;

End;

{***************************************************************************
 * Compara Valori Simple                                                   *
 *                                                                         *
 * Controlla se una stringa  contenuta nell'altra                         *
 *                                                                         *
 * Nome      Descrizione                                                   *
 * --------- ------------------------------------------------------------- *
 * v1        Stringa da ricercare, se  vuota la riceva  sempre positiva  *
 * v2        Campo in cui effeturare la ricerca                            *
 ***************************************************************************}
function compara_valori_Simple(v1,v2 : string):Boolean;
var fl : Boolean;
Begin
  fl := True;
  v1 := UpperCase(Trim(v1));
  v2 := UpperCase(Trim(v2));
  if(v1<>'') Then
  Begin
    fl := Pos(v1,v2)>0;
  End;
  compara_valori_simple := fl;

End;

{***************************************************************************
 *                                    aTOi                                 *
 ***************************************************************************}
Function aTOi(Num:String):Integer;
Var
    vl,fl : Integer;
Begin
  Val(Num,vl,fl);
  aTOi:=vl;
End;

{******************************************************************************
 *                                Format_Str                                  *
 *                                                                            *
 * Nome       Descrizione                                                     *
 * ---------- --------------------------------------------------------------- *
 * Txt        Testo da formattare                                             *
 * Lunghezza  Lunghezza da ottenere                                           *
 * Destra     False: Aggiunge spazi a destra                                  *
 *            True: Aggiunge spazi a sinistra                                 *
 ******************************************************************************}
Function Format_Str(Txt:String;Lunghezza:Integer;Destra:Boolean):String;
Begin
  Txt := Copy(Txt,1,Lunghezza);

  While(Length(Txt)<Lunghezza) Do
  begin
    if (Not Destra)Then Txt := Txt + ' '
    Else Txt := ' ' + Txt
  end;
  Format_Str := Txt;
End;

{***************************************************************************
 *                                                                         *
 ***************************************************************************}
function  codifica_stringa(txt1:string) : string;
var txt2 : string;
    c1   : integer;
begin
  txt1 := trim(txt1);
  txt2 := '';
  if (txt1<>'') then
  begin
    for c1 := 1 to length(txt1) do
    begin
      if (txt1[c1]='|') then
      begin
        txt2 := txt2 + '\';
      end;
      txt2 := txt2 + txt1[c1];
    end;
  end;
  codifica_stringa := txt2;
end;

{***************************************************************************
 *                                                                         *
 ***************************************************************************}
function  get_codifica_stringa(var txt1:string) : string;
var txt2       : string;
    c1         : integer;
    flag       : boolean;
    fine_frase : Boolean;
begin
  txt1 := trim(txt1);
  txt2 := '';
  flag := False;
  fine_frase := True;
  if (txt1<>'') then
  begin
    for c1 := 1 to length(txt1) do
    begin
      if (txt1[c1]='\') then
      begin
        Flag := True;
      end
      else
      begin
        if (txt1[c1]='|') and (Not Flag) then
        begin
          fine_frase := False;
          delete(txt1,1,c1);
          break;
        end;
        txt2 := txt2 + txt1[c1];
        flag := False;
      end;
    end;
  end;
  if (Fine_Frase) then txt1 := ''; 
  get_codifica_stringa := txt2;
end;

{***************************************************************************
 *                                                                         *
 ***************************************************************************}
Function GetColorPlanesNumber : Integer;
var
  DisplayDC : HDC;
  NumPlanes : Integer;
begin
  DisplayDC := CreateDC('DISPLAY',Nil,Nil,Nil);
  If (DisplayDC = 0) Then
  begin
    GetColorPlanesNumber := 4;
    Exit;
  end;
  NumPlanes := GetDeviceCaps(DisplayDC,BITSPIXEL);
  NumPlanes := NumPlanes * GetDeviceCaps(DisplayDC,PLANES);
  DeleteDC(DisplayDC);
  GetColorPlanesNumber := NumPlanes;
end;

{******************************************************************************
 * Stato file                                                                 *
 *                                                                            *
 *                                                                            *
 * Ritorna:                                                                   *
 *    0: Ok                                                                   *
 *    1: File non esiste                                                      *
 *    2: Errore generico                                                      *
 *    3: Sole lettura                                                         *
 ******************************************************************************}
function stato_file(x:String):Integer;
var fl, app1   : Integer;
    attr       : Integer;
    F          : TSearchRec;
begin
  attr := faAnyFile;
  fl := 2; // Di default pone in errore
  if (FileExists(x)) then
  begin
     App1 := FindFirst(x, Attr, F);
     if (App1=0) Then
     begin
       if (F.Attr and faReadOnly<>0) then fl := 3
       else fl := 0;
       FindClose(App1);
     end
  end
  else
  begin
    fl := 1;
  end;
  stato_file := fl;
end;


{******************************************************************************
 * Cera_dir                                                                   *
 ******************************************************************************}
function Crea_dir (nome:string):Integer;
var num : integer;
Begin
  {$I-}
  if(Nome[Length(nome)]='\') then  Delete(Nome,Length(nome),1);
  ChDir(Nome);
  if(ioresult<>0) Then
  Begin
    MkDir(nome);
  End;
  num := ioresult;
  {$I+}
  Crea_dir := num;
End;

{******************************************************************************
 * crea_percorsi                                                              *
 ******************************************************************************}
function crea_percorsi : integer;
Var Num : Integer;
    txt : String;
Begin
 txt := Completa_Percorso(ExtractFilePath(Application.ExeName));
 num := 0;
 if (FileGetAttr(txt+'soci'))<>faDirectory then num := Crea_Dir(txt+'soci');
 if (FileGetAttr(txt+'book'))<>faDirectory then num := Crea_Dir(txt+'book');
 crea_percorsi := num;
End;

end.
